var fs = require('fs');
var http = require('http');
var path = require('path');

function file_route(filename) { // return file route with filename
  var route = __dirname + '/drawer/';
  var file_extname = path.extname(filename);

  if(file_extname == '.txt') {
    route += 'document/'+ filename;
  }
  else if (file_extname == '.png' || file_extname == '.jpg' || file_extname === '.gif' 
    || file_extname == '.bmp' || file_extname == '.tiff') {
    route += 'photo/'+filename;
  }
  else if (file_extname == '.js') {
    route += 'javascript/'+ filename;
  } 
  else if (file_extname == '.html') {
    route += 'html/' + filename;
  }
  else if (file_extname == '.mp3') {
    route += 'music/' + filename;
  }
  else {
    route += 'etc/' + filename;
  }
  return route;
};

var Drawer = function() {
//  events.EventEmitter.call(this);
};

Drawer.prototype.init = function() {
  if(!fs.exists('./drawer')) {//TODO: Rewrite, deprecated
    fs.mkdir('./drawer');
    fs.mkdir('./drawer/photo');
    fs.mkdir('./drawer/music');
    fs.mkdir('./drawer/document');
    fs.mkdir('./drawer/javascript');
    fs.mkdir('./drawer/html');
    fs.mkdir('./drawer/etc');
    console.log('set your drawer');
  }
  else {
    console.log('drawer already exists');
  };
};

Drawer.prototype.writeFile = function (filename, data) {
  var route = file_route(filename);
  fs.writeFile(route, data, function (err){
    if (err) throw err;
    console.log(filename + " is saved");
  });
};

Drawer.prototype.readFile = function(filename) {
  console.log("from readFile: " + file_route(filename));
  fs.readFile(file_route(filename), function (err, data) {
      if (err) throw err;
      if (data) console.log(data.toString('utf8'));
  });
};

var findDir = function (filename) {
  var route = file_route(filename);
  var routeSplit = route.split('/');
  var routeSplice = routeSplit.splice(routeSplit.length - 3, 2);
  var routeDirOnly = routeSplice.join('/');
  console.log(routeDirOnly);
  return routeDirOnly;
};

Drawer.prototype.readDir = function(filename) {
  var route = file_route(filename);
  console.log("from readDir: " + route);
  var dir = findDir(filename);

  fs.readdir(dir, function (err, files) {
    if (err) throw err;

    //this code comes from nodeexamples.com/2012/09/28/getting-a-directory-listing-using-the-fs-module-in-node-js/
    files.map(function (files) {
      return path.join(dir, files);
    }).filter(function (files) {
      return fs.statSync(files).isFile();
    }).forEach(function (files) {
      console.log("This directory contains: ", path.extname(files));
    });
    //end code
  });
};

Drawer.prototype.removeFile = function (filename, err) {
  var route = file_route(filename);
  fs.unlinkSync(route);
  if (err) throw err;
  console.log("Removed file: " + filename);
};

module.exports = Drawer;